技术文章
当前位置:首页 > Java技术文章 > java的异常与处理机制分析【附面试题】

java异常与处理机制分析

  • 发布时间:
  • 作者:码农之家原创
  • 点击:120

这篇文章主要知识点是关于java、异常、处理机制、java异常处理教程及实例总结 的内容,如果大家想对相关知识点有系统深入的学习,可以参阅以下java相关的电子书

Effective Java中文版
  • 类型:java大小:197.6 MB格式:PDF出版:机械工业出版社作者:约书亚
立即下载

更多Java相关的学习资源可以参阅 Java电子书程序设计电子书 等栏目。

java的异常与处理机制分析【附面试题】

本文实例讲述了java的异常与处理机制。分享给大家供大家参考,具体如下:

java的异常机制

Throwable类

Throwable类是Java异常类型的顶层父类,一个对象只有是 Throwable 类的(直接或者间接)实例,他才是一个异常对象,才能被异常处理机制识别。JDK中内建了一些常用的异常类,我们也可以自定义异常。

Throwable又派生出Error类和Exception类。

错误:Error类以及他的子类的实例,代表了JVM本身的错误。错误不能被程序员通过代码处理,Error很少出现。因此,程序员应该关注Exception为父类的分支下的各种异常类。

异常:Exception以及他的子类,代表程序运行时发送的各种不期望发生的事件。可以被Java异常处理机制使用,是异常处理的核心。

java异常体系结构

java的异常与处理机制分析【附面试题】

Java中的异常分为两大类(根据javac对异常的处理要求):

Checked exception(受检异常):除了Error 和 RuntimeException的其它异常。受检异常表示程序本身没有问题,但由于I/O、网络、数据库等其他不可预测的错误导致的异常,也可能是因为资源耗尽导致的异常。javac强制要求程序员为这样的异常做预备处理工作(使用try…catch…finally或者throws)。在方法中要么用try-catch语句捕获它并处理,要么用throws子句声明抛出它,否则编译不会通过。这样的异常一般是由程序的运行环境导致的。因为程序可能被运行在各种未知的环境下,而程序员无法干预用户如何使用他编写的程序,于是程序员就应该为这样的异常时刻准备着。如SQLException , IOException,ClassNotFoundException 等。

Unchecked exception(Runtime Exception)(未受检异常):Error 和 RuntimeException 以及他们的子类。未受检异常一般认为是代码的逻辑问题,一般需要修改代码来解决异常,也可以使用异常机制处理。这样的异常发生的原因多半是代码写的有问题。如除0错误ArithmeticException,错误的强制类型转换错误ClassCastException,数组索引越界ArrayIndexOutOfBoundsException,使用了空对象NullPointerException等等。

Runtime Exception类直接继承自Exception类,Java中所有的运行时异常都会直接或间接地继承自Runtime Exception

Java中凡是继承自Exception,而不是继承自Runtime Exception类的异常都是Checked Exception

异常处理的基本语法

在编写代码处理异常时,对于检查异常,有2种不同的处理方式:使用try…catch…finally语句块处理它。或者,在函数签名中使用throws 声明交给函数调用者caller去解决。

(1)try…catch…finally语句块

try{
   //try块中放可能发生异常的代码。
   //如果执行完try且不发生异常,则接着去执行finally块和finally后面的代码(如果有的话)。
   //如果发生异常,则尝试去匹配catch块。
}catch(SQLException SQLexception){
  //每一个catch块用于捕获并处理一个特定的异常,或者这异常类型的子类。Java7中可以将多个异常声明在一个catch中。
  //catch后面的括号定义了异常类型和异常参数。如果异常与之匹配且是最先匹配到的,则虚拟机将使用这个catch块来处理异常。
  //在catch块中可以使用这个块的异常参数来获取异常的相关信息。异常参数是这个catch块中的局部变量,其它块不能访问。
  //如果当前try块中发生的异常在后续的所有catch中都没捕获到,则先去执行finally,然后到这个函数的外部caller中去匹配异常处理器。
  //如果try中没有发生异常,则所有的catch块将被忽略。
}catch(Exception exception){
  //...
}finally{
  //finally块通常是可选的。
  //无论异常是否发生,异常是否匹配被处理,finally都会执行。
  //一个try至少要有一个catch块,否则, 至少要有1个finally块。但是finally不是用来处理异常的,finally不会捕获异常。
//如果在try或者catch语句中存在return语句,则return语句会在finally语句执行结束后执行,但是finally并不能改变返回值。
//如果在finally语句中也有return,那么try和catch中的return语句会丢失,实际会返回finally中的返回值。
 //finally主要做一些清理工作,如流的关闭,数据库连接的关闭等。
}

注意点:

try块中的局部变量和catch块中的局部变量(包括异常变量),以及finally中的局部变量,他们之间不可共享使用。

每一个catch块用于处理一个异常。异常匹配是按照catch块的顺序从上往下寻找的,只有第一个匹配的catch会得到执行。匹配时,不仅运行精确匹配,也支持父类匹配,因此,如果同一个try块下的多个catch异常类型有父子关系,应该将子类异常放在前面,父类异常放在后面,这样保证每个catch块都有存在的意义。

finally块不管异常是否发生,只要对应的try执行了,则它一定也执行。只有一种方法让finally块不执行:System.exit()。因此finally块通常用来做资源释放操作:关闭文件,关闭数据库连接等等。良好的编程习惯是:在try块中打开资源,在finally块中清理释放这些资源。

finally块没有处理异常的能力。处理异常的只能是catch块。

在同一try…catch…finally块中 ,如果try中抛出异常,且有匹配的catch块,则先执行catch块,再执行finally块。如果没有catch块匹配,则先执行finally,然后去外面的调用者中寻找合适的catch块。

在同一try…catch…finally块中 ,try发生异常,且匹配的catch块中处理异常时也抛出异常,那么后面的finally也会执行:首先执行finally块,然后去外围调用者中寻找合适的catch块。

(2)throws 函数声明

throws声明:如果一个方法内部的代码会抛出检查异常(checked exception),而方法自己又没有完全处理掉,则javac保证你必须在方法的签名上使用throws关键字声明这些可能抛出的异常,否则编译不通过。

throws是另一种处理异常的方式,它不同于try…catch…finally,throws仅仅是将函数中可能出现的异常向调用者声明,而自己则不具体处理。

采取这种异常处理的原因可能是:方法本身不知道如何处理这样的异常,或者说让调用者处理更好,调用者需要为可能发生的异常负责。

public void foo() throws ExceptionType1 , ExceptionType2 ,ExceptionTypeN
{
   //foo内部可以抛出 ExceptionType1 , ExceptionType2 ,ExceptionTypeN 类的异常,或者他们的子类的异常对象。
}

throw 异常抛出语句

语法 : throw exceptionObject

程序员也可以通过throw语句手动显式的抛出一个异常。throw语句的后面必须是一个异常对象。

在某个方法(如:a方法)中,使用throw new 异常,的方式抛出异常异常,即本方法不会对异常进行处理,而是由调用a 的方法b来处理(此时b会使用throws关键字抛出),如果b也被方法c调用,那么c来处理,逐层类推,直到main方法,如果main方法也是选择抛出异常,那么就叫交给JVM处理

throw 语句必须写在函数中,执行throw 语句的地方就是一个异常抛出点,它和由JRE自动形成的异常抛出点没有任何差别。

package practice;
public class ExceptionTest {
    public static void test(Object obj) {
        try {
            if (obj == null) {
                throw new Exception();// 此处抛出的异常,在catch中被处理了
            }
        } catch (Exception e) {
            System.out.println("nullpoint");
        }
    }
    public static void test2(Object obj) throws Exception {
        try {
            obj.toString();
        } catch (Exception e) {
            throw new Exception();//在catch块中抛出新的异常,构成了异常链,这是因为原来的异常对象e可能不能处理这个异常,需要另一个异常对象来处理该异常
        }
    }
    public static void test1(Object obj) throws Exception {
        if (obj == null) {
            throw new Exception();// 此处抛出的异常,通过throws的方式,由调用test的方法处理
        }
    }
    public static void main(String[] args) throws Exception{
        ExceptionTest.test(null);
        //处理抛出异常的两种方式
        //方式一:test2函数使用throws抛出了异常,所以得接住这个异常,并处理
        try {
            ExceptionTest.test2(null);
        }catch(Exception e) {
            System.out.println("nullpoint");
        }
        //方式二:test1抛出的异常使用Throws的方式处理
        ExceptionTest.test1(null);
    }
}

自定义异常

自定义异常:通常就是定义了一个继承自Exception类的子类,那么这个类就是一个自定义异常类。通常情况下,我们都会直接继承自Exception类,一般不会继承某个运行时的异常类

异常的特性:

一个try可以有多个catch块,但运行时只有一个catch块可以被执行,并且是按照顺序来寻找匹配的catch块的,所以需要将父类的异常需要放在后面的catch块中

try{
test.method(str);
}catch (MyException e)
{
System.out.println("MyException catch");
e.printStackTrace();
}catch(MyException2 e)
{
System.out.println("MyException2 catch");
e.printStackTrace();
}catch(Exception e)
{
System.out.println(“Exception catch”);
e.printStackTrace();
}
finally
{System.out.println("finally");
}

try{
test.method(str);
}catch(Exception e)
{
System.out.println(“Exception catch”);
e.printStackTrace();
}
catch (MyException e)
{
System.out.println("MyException catch");
e.printStackTrace();
}catch(MyException2 e)
{
System.out.println("MyException2 catch");
e.printStackTrace();
}
finally
{System.out.println("finally");
}

面试题目

题目一:

package defineexception;
public class ExceptionTest3
{
    public void method()
    {
        try
        {
            System.out.println("try");
            return;
        }
        catch(Exception ex)
        {
            System.out.println("异常发生了");
        }
        finally
        {
            System.out.println("finally");
        }
        System.out.println("异常处理后续的代码");
    }
    public static void main(String[] args)
    {
        ExceptionTest3 test =new ExceptionTest3();
        test.method();
    }
}

结果:

try
finally

分析

try块中存在return语句,那么首先也需要将finally块中的代码执行完毕,再执行return语句,而且之后的其他代码也不会再执行了

题目二:

package defineexception;
public class ExceptionTest3
{
    public void method()
    {
        try
        {
            System.out.println("try");
            System.exit(0);
        }
        catch(Exception ex)
        {
            System.out.println("异常发生了");
        }
        finally
        {
            System.out.println("finally");
        }
        System.out.println("异常处理后续的代码");
    }
    public static void main(String[] args)
    {
        ExceptionTest3 test =new ExceptionTest3();
        test.method();
    }
}

结果

try

分析

先执行try块中的System.exit(0)语句,已经退出了虚拟机系统,所以不会执行finally块的代码

希望本文所述对大家java程序设计有所帮助。

java异常处理教程及实例总结

Java异常处理实例教程

1、什么是异常?
首先,让我们来看看下图的例子:
在这个例子中,存在的错误码由除以0的结果。由于除以0而导致异常: ArithmeticException
HelloException.java

package com.yiibai.tutorial.exception;

public class HelloException {

  public static void main(String[] args) {

    System.out.println("Three");

    // This division no problem.
    int value = 10 / 2;

    System.out.println("Two");

    // This division no problem.
    value = 10 / 1;

    System.out.println("One");
    
    // This division has problem, divided by 0.
    // An error has occurred here.
    value = 10 / 0;

    // And the following code will not be executed.
    System.out.println("Let's go!");

  }

}

运行这个例子,得到的结果是:

可以看到控制台屏幕上的通知。错误通知是很清楚的,包括代码行的信息。
让我们通过下图中的流程看看下面的程序:

  • 程序从(1),(2)至(5)步骤正常运行。
  • 在步骤(6)程序除以0。
  • 程序跳转出 main 方法后,而(7)代码行还没有被执行。

我们将修改上述实施例的代码。

HelloCatchException.java

package com.yiibai.tutorial.exception;

public class HelloCatchException {

  public static void main(String[] args) {

    System.out.println("Three");

    // This division no problem.
    int value = 10 / 2;

    System.out.println("Two");

    // This division no problem.
    value = 10 / 1;

    System.out.println("One");

    try {
      // This division has problem, divided by 0.
      // An error has occurred here.      
      value = 10 / 0;

      // And the following code will not be executed.
      System.out.println("Value =" + value);

    } catch (ArithmeticException e) {

      // The code in the catch block will be executed
      System.out.println("Error: " + e.getMessage());

      // The code in the catch block will be executed
      System.out.println("Ignore...");

    }

    // This code is executed
    System.out.println("Let's go!");

  }

}

运行示例结果:

Three

Two

One

Error: / by zero

Ignore...

Let's go!

我们将按以下实例图像的流程来解释下面的程序。

  • 步骤(1)至(5)是完全正常的。
  • 异常发生在步骤(6),除以0出现了问题。
  • 它立即跳到catch块执行命令,步骤(7)被跳过。
  • 步骤(8),(9)被执行。
  • 步骤(10)被执行。

2、 异常层次结构
这是Java异常的分层图的模型。

最高的类是:Throwable

两个直接子类是 Error 和 Exception。

在异常转移有一个RuntimeException子类,包括Java中的编译时未检查异常。检查并取消检查在编译时,在下一部分的实施示例中说明。

注意:您的类应该从两个分支:Error或Exception继承,而不是直接从Throwable继承。

当一个动态链接失败,或在虚拟机的一些其他的“硬”故障发生时,虚拟机引发这个错误。典型的Java程序不捕获错误,所以Java程序都不会抛出任何错误。大多数程序抛出并捕获从Exception类派生的对象。异常指示出现了一个问题,但是这些问题并不是严重系统性问题。你写的大多数程序将会抛出和捕获异常。

Exception类在Java包定义了许多子类。这些子类指明不同类型的可能会发生异常。 例如,NegativeArraySizeException表明程序试图创建一个大小为负的数组。

一个导演的子类在Java语言中的特殊含义: RuntimeException类表示Java虚拟机中发生(在运行期间)的异常。运行时异常的一个例子是NullYiibaierException异常,其中,当一种方法试图通过一个空引用来访问对象的成员时就会引发。 NullYiibaierException 可以在任何地方出现某个程序试图取消引用一个对象的引用。经常检查异常捕获的好处远远超过它的成本。

由于运行时异常是无所不在的,在试图捕获或指定所有的时间是徒劳的作法(不可读和不可维护的代码), 编译器允许运行时异常去未捕获和指定。
Java包定义几个RuntimeException类。您可以捕获这些异常,就像其他异常。但是并不需要一种方法来指定它抛出运行时异常。此外可以创建自己的RuntimeException子类。 运行时异常 - 下面讨论包含何时以及如何使用运行时异常进行了深入探讨。 3、使用try-catch处理异常

编写从Exception 继承的类。

AgeException.java

package com.yiibai.tutorial.exception.basic;

public class AgeException extends Exception {

  public AgeException(String message) {
    super(message);
  }

}
TooYoungException.java
package com.yiibai.tutorial.exception.basic;

public class TooYoungException extends AgeException {

 public TooYoungException(String message) {
   super(message);
 }

}

TooOldException.java

package com.yiibai.tutorial.exception.basic;

public class TooOldException extends AgeException {

 public TooOldException(String message) {
   super(message);
 }

}

以及AgeUtils类检查年龄的检查静态方法。
AgeUtils.java

package com.yiibai.tutorial.exception.basic;

public class AgeUtils {

 
  // This method checks the age.
  // If age is less than 18, the method will throw an exception TooYoungException
  // If age greater than 40, the method will throw an exception TooOldException
  public static void checkAge(int age) throws TooYoungException,
      TooOldException {
    if (age < 18) {

      // If age is less than 18, an exception will be thrown
      // This method ends here.
      throw new TooYoungException("Age " + age + " too young");
    } else if (age > 40) {

      // If age greater than 40, an exception will be thrown.
      // This method ends here.
      throw new TooOldException("Age " + age + " too old");
    }

    // If age is between 18-40.
    // This code will be execute.
    System.out.println("Age " + age + " OK!");
  }
}

检查异常和未经检查的异常:
AgeException是Exception,TooOldException的子类和TooYoungException2是 AgeException直接子类,所以它们是“Checked Exception”
在AgeUtils.checkAge(int)方法已经抛出异常,需要通过关键字“throws”,列出它们的方法声明。或者可以声明抛出更多的级别。
在使用 AgeUtils.checkAge(int) 位置也必须进行处理,以捕获异常,或继续抛出去。

"Checked exception" 是由 "Java Compiler"来检查。

有两个选择:

TryCatchDemo1.java

package com.yiibai.tutorial.exception.basic;

public class TryCatchDemo1 {

  public static void main(String[] args) {


    System.out.println("Start Recruiting ...");
    // Check age
    System.out.println("Check your Age");
    int age = 50;

    try {

      AgeUtils.checkAge(age);

      System.out.println("You pass!");

    } catch (TooYoungException e) {

      // Do something here ..
      System.out.println("You are too young, not pass!");
      System.out.println(e.getMessage());

    } catch (TooOldException e) {

      // Do something here ..
      System.out.println("You are too old, not pass!");
      System.out.println(e.getMessage());

    }

  }
}

在下面的例子中,我们将通过父类捕获异常(超Exception类)。
TryCatchDemo2.java

package com.yiibai.tutorial.exception.basic;

public class TryCatchDemo2 {

  public static void main(String[] args) {

    System.out.println("Start Recruiting ...");
    // Check age
    System.out.println("Check your Age");
    int age = 15;

    try {

      // Here can throw TooOldException or TooYoungException
      AgeUtils.checkAge(age);

      System.out.println("You pass!");

    } catch (AgeException e) {
      
      // If an exception occurs, type of AgeException
      // This catch block will be execute
      System.out.println("Your age invalid, you not pass");
      System.out.println(e.getMessage());

    }
  }
}

也可以组不同的异常在块中来处理,如果它们对逻辑程序处理是相同的方式。
TryCatchDemo3.java

package com.yiibai.tutorial.exception.basic;

public class TryCatchDemo3 {

  public static void main(String[] args) {

    System.out.println("Start Recruiting ...");
    // Check age
    System.out.println("Check your Age");
    int age = 15;

    try {

      // Here can throw TooOldException or TooYoungException
      AgeUtils.checkAge(age);

      System.out.println("You pass!");

    } catch (TooYoungException | TooOldException e) {
      // Catch multi exceptions in one block.

      System.out.println("Your age invalid, you not pass");
      System.out.println(e.getMessage());

    }
  }

}

4、 try-catch-finally
我们已习惯于通过 try-catch 块捕获错误。Try-catch-finally 来完全处理异常。

try {

  // Do something here

} catch (Exception1 e) {

  // Do something here

} catch (Exception2 e) {

  // Do something here

} finally {

  // Finally block is always executed
  // Do something here

}

TryCatchFinallyDemo.java

package com.yiibai.tutorial.exception.basic;

public class TryCatchFinallyDemo {

  public static void main(String[] args) {

    String text = "001234A2";

    int value = toInteger(text);

    System.out.println("Value= " + value);

  }

  public static int toInteger(String text) {
    try {

      System.out.println("Begin parse text: " + text);

      // An Exception can throw here (NumberFormatException).
      int value = Integer.parseInt(text);

      return value;

    } catch (NumberFormatException e) {

      
      // In the case of 'text' is not a number.
      // This catch block will be executed.      
      System.out.println("Number format exception " + e.getMessage());

      // Returns 0 if NumberFormatException occurs
      return 0;

    } finally {

      System.out.println("End parse text: " + text);

    }
  }

}

这是程序的流程。 finally块无论什么情况下总会被执行。

5、 环绕异常

  • 我们需要一些类参与到这个例子:
  • Person: 模拟一个受试者招募到公司的信息:姓名,年龄,性别。
  • GenderException: 性别异常。
  • ValidateException: 异常评估求职者。
  • ValidateUtils: 静态方法类综合评价面试者。
  • 如果男性年龄在18-40之间的被认为是有效的。

Person.java

package com.yiibai.tutorial.exception.wrap;

public class Person {

  public static final String MALE = "male";
  public static final String FEMALE = "female";

  private String name;
  private String gender;
  private int age;

  public Person(String name, String gender, int age) {
    this.name = name;
    this.gender = gender;
    this.age = age;
  }

  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public String getGender() {
    return gender;
  }

  public void setGender(String gender) {
    this.gender = gender;
  }

  public int getAge() {
    return age;
  }

  public void setAge(int age) {
    this.age = age;
  }
}

GenderException.java

package com.yiibai.tutorial.exception.wrap;

// Gender Exception.
public class GenderException extends Exception {

   public GenderException(String message) {
     super(message);
   }
}

ValidateException 类包有其他异常。
ValidateException.java

package com.yiibai.tutorial.exception.wrap;

public class ValidateException extends Exception {
  
  // Wrap an Exception
  public ValidateException(Exception e) {
    super(e);
  }

}

ValidateUtils.java

package com.yiibai.tutorial.exception.wrap;

import com.yiibai.tutorial.exception.basic.AgeUtils;

public class ValidateUtils {

  public static void checkPerson(Person person) throws ValidateException {
    try {

      // Check age.
      // Valid if between 18-40
      // This method can throw TooOldException, TooYoungException.    
      AgeUtils.checkAge(person.getAge());

    } catch (Exception e) {
      
      // If not valid
      // Wrap this exception by ValidateException, and throw
      throw new ValidateException(e);

    }

    // If that person is Female, ie invalid.
    if (person.getGender().equals(Person.FEMALE)) {

      GenderException e = new GenderException("Do not accept women");
      throw new ValidateException(e);

    }
  }

}

WrapperExceptionDemo.java

package com.yiibai.tutorial.exception.wrap;

public class WrapperExceptionDemo {

  public static void main(String[] args) {
    
    // One participant recruitment.
    Person person = new Person("Marry", Person.FEMALE, 20);

    try {

      // Exceptions may occur here.
      ValidateUtils.checkPerson(person);

    } catch (ValidateException wrap) {

      // Get the real cause.
      // May be TooYoungException, TooOldException, GenderException
      Exception cause = (Exception) wrap.getCause();

      if (cause != null) {
        System.out.println("Not pass, cause: " + cause.getMessage());
      } else {
        System.out.println(wrap.getMessage());
      }

    }
  }

}

6、RuntimeException和子类 RuntimeException类及其子类都是“未检查的例外”。它不是由Java编译器在编译时进行检查。在某些情况下,你可以从这个分支继承编写自己的异常。

下面是属于RuntimeException分支一些类(当然,这还不是全部)。
一些处理这种类型异常的例子:

6.1- NullYiibaierException
这是最常见的异常,通常会导致错误在程序中。异常被抛出,当你调用方法或访问一个空对象的字段。
NullYiibaierExceptionDemo.java

package com.yiibai.tutorial.exception.runtime;

public class NullYiibaierExceptionDemo {

  // For example, here is a method that can return null string.
  public static String getString() {
    if (1 == 2) {
      return "1==2 !!";
    }
    return null;
  }

  public static void main(String[] args) {

    // This is an object that references not null.
    String text1 = "Hello exception";

    // Call the method retrieves the string length.
    int length = text1.length();

    System.out.println("Length text1 = " + length);

    // This is an object that references null.
    String text2 = getString();
    
    // Call the method retrieves the string length.
    // NullYiibaierException will occur here.
    // It is an exception occurs at runtime (type of RuntimeException)
    // Javac compiler does not force you to use a try-catch block to handle it
    length = text2.length();

    System.out.println("Finish!");
  }

}

运行示例的结果:

在现实中,像处理其他异常时,可以使用 try-catch 来捕获并处理这个异常。 然而,这是机械的,通常情况下,我们应该检查,以确保在使用它之前,对象不为空值。
您可以更正上面的代码,使其类似于下面的以避免空指针异常:

// This is a null object.
String text2 = getString();

// Check to make sure 'Text2' are not null.
// Instead of using try-catch.
if (text2 != null) {
 length = text2.length();
}

6.2- ArrayIndexOfBoundException
当您试图访问一个无效的索引的数组元素就会发生此异常。例如,一个数组有10个元素可以访问,但您访问的是索引为20的元素。
ArrayIndexOfBoundsExceptionDemo.java

package com.yiibai.tutorial.exception.runtime;

public class ArrayIndexOfBoundsExceptionDemo {

  public static void main(String[] args) {

    String[] strs = new String[] { "One", "Two", "Three" };

    // Access to the element has index 0.
    String str1 = strs[0];

    System.out.println("String at 0 = " + str1);

    
    // Access to the element has index 5.
    // ArrayIndexOfBoundsException occur here.
    String str2 = strs[5];

    System.out.println("String at 5 = " + str2);

  }

}

为了避免 ArrayIndexOfBoundsException,我们更多的应该是检查数组而不是使用try-catch。

if (strs.length > 5) {
  String str2 = strs[5];
  System.out.println("String at 5 = " + str2);
} else {
  System.out.println("No elements with index 5");
}

以上就是本文的全部内容,希望对大家的学习有所帮助。

Java学习笔记之异常处理

一.异常的分类

1.由Java虚拟机抛出的异常(Error):程序无法处理的问题,用户不用去进行处理(虚拟机错误丶内存溢出错误丶线程死锁)

2.Exception异常:程序本身可以进行处理的异常

1).非检查异常(Unchecked Exception):编译器不需要强制处理的异常(空指针异常丶数组下标越界异常丶算数异常丶类型转换异常)

2).检查异常(checked Exception):编译器需要强制处理的异常(IOException丶SQLException) 

二.异常处理的两种方法

1.通过try丶catch和finally关键字在当前位置进行异常处理

public static void main(String[] a){
 int sum = 0;
 while(true){
  try {  //以两数相除除数不能为0进行举例
   System.out.println("请依次输入两个数值进行除法操作:");
   Scanner scanner = new Scanner(System.in);
   int one =scanner.nextInt();
   int two =scanner.nextInt();
   sum = one/two;
   System.out.println("最终结果为:"+sum);
  } catch (Exception e) {    //用catch将错误进行捕捉,这里可以使用多重catch,对于不同的错误进行捕捉,但最后的catch建议为Exception。
   // TODO Auto-generated catch block //显示错误堆栈信息
   e.printStackTrace();                          
  }finally{            

 System.out.print("无论有没有错误我都会执行");          }
 }
 }
}

输出:

2.通过try丶catch丶finally丶throw和throws抛出异常给函数调用者进行处理

public class Try {
 public static void main(String[] a){
  try{
   Function();  //在函数调用者处对异常进行处理
  }catch(Exception e)
  {
   e.printStackTrace();
  } 
 }
 static void Function() throws Exception{  //通过throws将异常进行抛出
  
  System.out.println("请输入一个数值进行判断:");
  Scanner scanner = new Scanner(System.in);
  int one =scanner.nextInt();
  if(one<100)
  {
   throw new Exception(); //若输入的数值小于100则抛出异常
  }
 } 
}

输出:

3.自定义异常进行处理

class MyException extends Exception{  //自定义异常,通过super方法传递异常信息给父级
 public MyException(){
 super("这是我自定义的异常");
 }
}
 
public class Try {
 public static void main(String[] a){
  try{
   Function();
  }catch(MyException e)
  {
   e.printStackTrace();
  } 
 }
 static void Function() throws MyException{
  
  System.out.println("请输入一个数值进行判断:");
  Scanner scanner = new Scanner(System.in);
  int one =scanner.nextInt();
  if(one<100)
  {
   throw new MyException(); //将自定义异常进行抛出  
  }
 } 
}

输出:

三.异常链

有的时候我们会在处理一个异常的时候抛出一个新的异常,也就是异常的嵌套,但是最后我们得到的异常信息却只有一个。

示例:

public class Try {
 public static void main(String[] a){
  try{
   Function1();
  }catch(Exception e)
  {
   e.printStackTrace();
  } 
 }
 static void Function1() throws Exception{
  try{
   Function2();
  }catch(Exception e){
   throw new Exception();
  }
 } 
 static void Function2() throws Exception{
  try{
   Function3();
  }catch(Exception e){
   throw new Exception();
  }
 } 
 static void Function3() throws Exception{
   throw new Exception();
 } 
}

输入结果:

这样的话显示出的异常就只有一个了,那我们如果想让这条异常链中的所有异常信息全部输出该怎么办呢?方法很简单,我们在抛出异常的时候将异常对象也当作参数进行抛出就行了。

示例:

public class Try {
 public static void main(String[] a){
  try{
   Function1();
  }catch(Exception e)
  {
   e.printStackTrace();
  } 
 }
 static void Function1() throws Exception{
  try{
   Function2();
  }catch(Exception e){
   throw new Exception("异常2",e);
  }
 } 
 static void Function2() throws Exception{
  try{
   Function3();
  }catch(Exception e){
   throw new Exception("异常2",e);
  }
 } 
 static void Function3() throws Exception{
   throw new Exception("异常3");
 } 
}

运行结果:

到此,我们Java中的异常便是描述完了。

以上就是本次给大家分享的关于Java的全部知识点内容总结,大家还可以在下方相关文章里找到swing组件JScrollPane滚动条实、 WebUploader实现分片断点上传、 Java IO流之字符缓冲流的实、 等java文章进一步学习,感谢大家的阅读和支持。

上一篇:SpringBoot使用统一异常处理实例讲解

下一篇:Protostuff序列化和反序列化的使用详细说明

展开 +

收起 -

相关电子书
学习笔记
网友NO.846891

详谈Java 异常处理的误区和经验总结(分享)

本文着重介绍了 Java 异常选择和使用中的一些误区,希望各位读者能够熟练掌握异常处理的一些注意点和原则,注意总结和归纳。只有处理好了异常,才能提升开发人员的基本素养,提高系统的健壮性,提升用户体验,提高产品的价值。 误区一、异常的选择 图 1. 异常分类 图 1 描述了异常的结构,其实我们都知道异常分检测异常和非检测异常,但是在实际中又混淆了这两种异常的应用。由于非检测异常使用方便,很多开发人员就认为检测异常没什么用处。其实异常的应用情景可以概括为以下: 一、调用代码不能继续执行,需要立即终止。出现这种情况的可能性太多太多,例如服务器连接不上、参数不正确等。这些时候都适用非检测异常,不需要调用代码的显式捕捉和处理,而且代码简洁明了。 二、调用代码需要进一步处理和恢复。假如将 SQLExcept……

网友NO.243478

Java中的异常和处理机制实例详解

本文实例讲述了Java中的异常和处理机制。分享给大家供大家参考,具体如下: 简介 程序运行时,发生的不被期望的事件,它阻止了程序按照程序员的预期正常执行,这就是异常。异常发生时,是任程序自生自灭,立刻退出终止,还是输出错误给用户?或者用C语言风格:用函数返回值作为执行状态?。 Java提供了更加优秀的解决办法:异常处理机制。 异常处理机制能让程序在异常发生时,按照代码的预先设定的异常处理逻辑,针对性地处理异常,让程序尽最大可能恢复正常并继续执行,且保持代码的清晰。 Java中的异常可以是函数中的语句执行时引发的,也可以是程序员通过throw 语句手动抛出的,只要在Java程序中产生了异常,就会用一个对应类型的异常对象来封装异常,JRE就会试图寻找异常处理程序来处理异常。 Throwable类是Java异常类型的顶层父类……

<
1
>

Copyright 2018-2020 xz577.com 码农之家

电子书资源由网友、会员提供上传,本站记录提供者的基本信息及资源来路

鸣谢: “ 码小辫 ” 公众号提供回调API服务、“ 脚本CDN ”提供网站加速(本站寻求更多赞助支持)

版权投诉 / 书籍推广 / 赞助:520161757@qq.com

上传资源(网友、会员均可提供)

查看最新会员资料及资源信息